#ifndef READ_GAME_DATA_H
#define READ_GAME_DATA_H

#include <pf/file.h> 
#include <pf/texture.h>
#include <pf/assetmap.h> 
#include <pf/sprite.h>
#include <vector>


class gameAssets {
public:
	gameAssets();
	~gameAssets();

	TAssetMap levelAssets1;
	TAssetMap levelAssets2;
private:
};



class spriteProperties {
public:
	float x,y,z,scale, r,g,b,a;
	int texture, hWidth, hHeight;
	float xT, yT, scaleT;
};

class SpritePropertiesManager {
public:
	void setSpriteData();

private:
	spriteProperties *sprites;

};




class oesRender
{
public:
	oesRender();
	~oesRender();
	void readHeader(const char *level);
	void load(const char *level);
	void updateSpritePositions();
	TSpriteRef spriteHolder;
	float camX, camY;
	TSpriteRef *gameSprites;
	int numObjects;
	spriteProperties *dSpriteProperties;
	int *spriteDrawList;
	TTextureRef *textureList;

private:
	

	static const int buffersize = 100;
	static const int textureBufferSize = 64;

	TFile *fileHandle;
	int lines;
	char* level;
	char** buffer;
	char filePath[256];
	int numFiles;
	
	TAssetMap levelAssets1;

	float x,y,z,scale,r,g,b,a;
	
};


bool sortZ(const spriteProperties* lhs, const spriteProperties* rhs);

#endif