//------------------------------------------------------------------
// Copyright (c) 2004-2006 PlayFirst, Inc. All rights reserved.
//
// This material is the confidential trade secret and proprietary
// information of PlayFirst, Inc. It may not be reproduced, used, disclosed,
// sold or transferred without the prior written consent of PlayFirst, Inc. 
// All rights reserved.
//------------------------------------------------------------------

#ifndef SETTINGS_H_INCLUDED
#define SETTINGS_H_INCLUDED


#include <pf/prefs.h>
#include <pf/pfhiscores.h>

class TSettings 
{
public:
	enum eGameMode { eGameMode1 = 0, eGameMode2, eMaxGameModes };

	static TSettings *GetInstance();
	static TSettings *CreateSettings();
	static void DeleteSettings();

	/// Initialize game using saved settings
	void InitGameToSettings();

	// Global helper functions
	void CreateNewUser(str userName);
	void ChangeCurrentUserName(str newName);
	str GetCurrentUserName();
	str GetUserName(int index);
	void SetCurrentUser(int userNum);
	int GetCurrentUser();
	int GetNumUsers();
	void DeleteUser(int userNum);
	bool IsNameInUse(str name);
	void QuitToMainMenu();

	eGameMode GetCurrentGameMode() {return mGameMode;}
	void SetCurrentGameMode(int gameMode);

	bool IsFullScreen();
	void UpdateFullScreen();
	bool ToggleFullScreen();

	void ToggleSoundMute();

	TPrefs *GetPreferences() {return mPreferences;}
	TPfHiscores *GetHiscores() {return mHiscores;}

private:
	TSettings();
	~TSettings();

	void SetSoundForCurrentUser();

	TPrefs			*mPreferences;
	TPfHiscores		*mHiscores;

	eGameMode		mGameMode;
};

#endif