//------------------------------------------------------------------
// Copyright (c) 2004-2006 PlayFirst, Inc. All rights reserved.
//
// This material is the confidential trade secret and proprietary
// information of PlayFirst, Inc. It may not be reproduced, used, disclosed,
// sold or transferred without the prior written consent of PlayFirst, Inc. 
// All rights reserved.
//------------------------------------------------------------------


/**
 * @file 
 * Implementation for class TSimpleDemo
 */


#include "simpledemo.h"
#include <pf/pflib.h>

PFTYPEIMPL_DC(TSimpleDemo);

TSimpleDemo::TSimpleDemo()
{

}

TSimpleDemo::~TSimpleDemo()
{

}

/**
 * Draw the window. Derived classes will override this
 * function and provide the draw functionality.
 */
void TSimpleDemo::Draw()
{
	
}

/**
 * Initialize the Window. Called by the system only in
 * Lua initialization.
 *
 * When you create your own custom window, this is where you put
 * your own custom initialization that needs to happen before
 * children are created. Fundamental window initialization is
 * handled in every class by this function, so <b>when you
 * override this function you almost always want to call your
 * base class to handle base class initialization.</b>
 */
void TSimpleDemo::Init(TWindowStyle & /*style*/)
{
}

/**
 * Mouse down handler.
 *
 * @param point      Location of mouse press in client coordinates.
 *
 * @return true if message was handled, false to keep searching
 *         for a handler.
 */
bool TSimpleDemo::OnMouseDown(const TPoint & /*point*/)
{
	return true;
}

/**
 * Mouse motion handler.
 *
 * @param point      Location of mouse in client coordinates.
 *
 * @return true if message was handled, false to keep searching
 *         for a handler.
 */
bool TSimpleDemo::OnMouseMove(const TPoint & /*point*/)
{
	return true;
}
